/** @name check_c.c --- Determine some C-compiler properties.
 * 
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE             @(#) %derived_by: guidod %
 *  @version %version: 4.24 %
 *    (%date_modified: Thu Jan 27 22:00:09 2000 %)
 *
 *  @description
 *          this is superseded by the capabilities of autoconf
 */
/*@{*/

#include <stdio.h>
#include <string.h>
#include <signal.h>

#define OFFSET(X,C)	(int)((char *)&(X.C) - (char *)&(X))
#define CELLSIZE	(sizeof (void *))

void sig_hdl (int sig) {}

int
main ()
{
  union
    {
      char c[sizeof (long)];
      int i;
      long l;
    }
  t;
  struct
    {
      char c;
      int i;
    }
  ti;
  struct
    {
      char c;
      long l;
    }
  tl;
  struct
    {
      char c;
      float f;
    }
  tf;
  struct
    {
      char c;
      double d;
    }
  td;
  int cellalign, sfloatalign, dfloatalign;

  memset (t.c, 0, sizeof t.c);
  /*
   * determine types for CELL and HALFCELL:
   */
  if (sizeof (int) == CELLSIZE)
    {
      t.i = 1;
      cellalign = OFFSET (ti, i);
      puts ("#define CELL_TYPE int");
      if (sizeof (short) == sizeof (int) / 2)
	  puts ("#define HALF_CELL_TYPE short");

      else
	puts ("#define HALF_CELL_TYPE char");
    }
  else if (sizeof (long) == CELLSIZE)
    {
      t.l = 1;
      cellalign = OFFSET (tl, l);
      puts ("#define CELL_TYPE long");
      if (sizeof (int) == sizeof (long) / 2)
	  puts ("#define HALF_CELL_TYPE int");
      else if (sizeof (short) == sizeof (long) / 2)
	  puts ("#define HALF_CELL_TYPE short");

      else
	puts ("#define HALF_CELL_TYPE char");
    }
  else
    puts ("#error \"could not determine type for Cell\"");

  /*
   * Determine endianess:
   */
  if (t.c[0] == 1)
    puts ("#define HIGHBYTE_FIRST 0");
  else
    puts ("#define HIGHBYTE_FIRST 1");

  /*
   * Determine alignment restrictions:
   */
  printf ("#define CELLSIZE %d\n", (int)CELLSIZE);
  printf ("#define SFLOATSIZE %d\n", (int)sizeof (float));
  printf ("#define DFLOATSIZE %d\n", (int)sizeof (double));

  sfloatalign = OFFSET (tf, f);
  dfloatalign = OFFSET (td, d);

  if (cellalign < CELLSIZE)
    cellalign = CELLSIZE;
  if (sfloatalign < cellalign)
    sfloatalign = cellalign;
  if (dfloatalign < sfloatalign)
    dfloatalign = sfloatalign;

  printf ("#define CELL_ALIGN %d\n", cellalign);
  printf ("#define SFLOAT_ALIGN %d\n", sfloatalign);
  printf ("#define DFLOAT_ALIGN %d\n", dfloatalign);

  /*
   * Determine if signals must be reinstalled:
   */
  signal (SIGTERM, sig_hdl);
  raise (SIGTERM);
  if (signal (SIGTERM, SIG_DFL) == sig_hdl)
    puts ("#define KEEPS_SIGNALS 1");

  return 0;
}

/*@}*/
