/** @name dblsub.h ---	Internals for double number (64 Bit) arithmetics.
 *
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE              @(#) %derived_by: guidod %
 *  @version %version: 4.25 %
 *    (%date_modified: Tue Apr 11 15:01:47 2000 %)
 *
 *  @description
 *              The basic routines, this is (duz 16Jul93), so
 *              you see how early the development started.
 */
/*@{*/

#ifndef __P4_DBLSUB_H
#define __P4_DBLSUB_H

#include "p4e.h"

void dasl (p4dcell * a, int n);
void dasr (p4dcell * a, int n);
void dnegate (p4dcell * a);
void madd (p4dcell * a, p4cell b);
void dadd (p4dcell * a, p4dcell * b);
void dsub (p4dcell * a, p4dcell * b);
int dless (p4dcell * a, p4dcell * b);
int duless (p4udcell * a, p4udcell * b);
p4udcell ummul (p4ucell a, p4ucell b);
p4dcell mmul (p4cell a, p4cell b);
udiv_t umdiv (p4udcell num, p4ucell denom);
fdiv_t smdiv (p4dcell num, p4cell denom);
fdiv_t fmdiv (p4dcell num, p4cell denom);

#endif
  /* ndef __P4_DBLSUB_H */
/*@}*/

