/** @name help.h --- declarations for FORTH online help utilities.
 *
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE           @(#) %derived_by: guidod %
 *  @version %version: 4.24 %
 *    (%date_modified: Thu Jan 27 21:55:19 2000 %)
 */
/*@{*/

#ifndef __P4_HELP_H
#define __P4_HELP_H

#include <limits.h>
#include "p4_macro.h"


typedef struct Hheader HHeader;	/* index file header */
typedef struct Hrecord HRecord;	/* record in index file */

struct Hheader
{
  char magic [4];		/* magic number */
  int nfiles;			/* how many help files are gathered */
  int nitems;			/* total items in this index */
};

struct Hrecord
{
  char name [32];		/* name of the definition */
  int fidx;			/* index of file, see head */
  long pos;			/* position in file */
};

extern char *progname;

void p4_fatal (const char *msg, ...);
void p4_sys_error (void);
void p4_file_errorz (const char *fn);
void p4_read_help_index (const char *pn, const char *fn);
void p4_print_help (const char *name);

#if defined STANDALONE
void *p4_xalloc (size_t size);
#endif

#endif
  /* ndef __P4_HELP_H */
/*@}*/
