/** @name MEMORY-ALLOC --- The Optional Memory Allocation Word Set
 * 
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE              @(#) %derived_by: guidod %
 *  @version %version: 4.27 %
 *    (%date_modified: Tue Apr 11 15:13:36 2000 %)
 *
 *  @description
 *     The optional memory allocation wordset interfaces to
 *     the surrounding OS heap memory management.
 */
/*@{*/
#if defined(__version_control__) && defined(__GNUC__)
static char* id __attribute__((unused)) = 
      "@(#) $Id: %full_filespec: memory.c~4.27:csrc:bln_12xx!4 %4 % $";
#endif

#define _P4_SOURCE 1

#include "p4sys.h"

#include <stdlib.h>
#include <errno.h>

#include "support.h"
#include "missing.h"
#include "p4_log.h"

FCode (p4_allocate)
{
  errno = 0;
  if ((*SP = (p4cell) p4_calloc (1, (size_t) * SP)) != 0)
       *--SP = 0;
  else *--SP = errno;
}

FCode (p4_free)
{
  errno = 0;
  { p4_xfree (*(void **) SP); }
  *SP = errno;
}

FCode (p4_resize)
{
  void *p;
  
  errno = 0;
  p = realloc ((void *) SP[1], (size_t) SP[0]);

  if (p == NULL)
  {
     SP[0] = errno;
  }else{          P4_debug2 (14, "realloc %p -> %p", (void*)SP[1], p);
     SP[0] = 0;
     SP[1] = (p4cell) p;
  }
}

LISTWORDS (memory) =
{
  CO ("ALLOCATE",	p4_allocate),
  CO ("FREE",		p4_free),
  CO ("RESIZE",		p4_resize),
};
COUNTWORDS (memory, "MEMORY-ALLOC-EXT Memory allocation");

/*@}*/

