/** @name missing.h ---	declarations sometimes missing.
 * 
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE            @(#) %derived_by: guidod %
 *  @version %version: 4.8 %
 *    (%date_modified: Thu Apr 27 14:16:33 2000 %)
 *
 *  @description
 *			This file is included after all system includes.
 */
/*@{*/

#ifndef STDIN_FILENO
# define STDIN_FILENO 0
#endif
#ifndef STDOUT_FILENO
# define STDOUT_FILENO 1
#endif
#ifndef STDERR_FILENO
# define STDERR_FILENO 2
#endif


#ifndef SEEK_SET
# define SEEK_SET 0		/* Set file pointer to "offset" */
#endif
#ifndef SEEK_CUR
# define SEEK_CUR 1		/* Set file pointer to current plus "offset" */
#endif
#ifndef SEEK_END
# define SEEK_END 2		/* Set file pointer to EOF plus "offset" */
#endif


#ifndef F_OK
# define F_OK 0
#endif
#ifndef X_OK
# define X_OK 1
#endif
#ifndef W_OK
# define W_OK 2
#endif
#ifndef R_OK
# define R_OK 4
#endif

#ifndef S_IREAD
# define S_IREAD S_IRUSR
#endif
#ifndef S_IWRITE
# define S_IWRITE S_IWUSR
#endif
#ifndef S_IEXEC
# define S_IEXEC S_IXUSR
#endif

#ifndef EPERM
# define EPERM -1
#endif


#if defined SYS_WC_OS2V2 && !defined SIG_ACK
# define SIG_ACK ((void (*)(int))4)
#endif

/* -------- config.h tells us if we have to provide these ------- */

#ifdef HAVE_CONFIG_H
#include "config.h"

#ifdef HAVE_ACOSH
#define HAVE_AH_TRIG
#else
double acosh (double);
double asinh (double);
double atanh (double);
#endif

#ifndef HAVE_POW10
#define pow10(X) pow (10.0, (X))
#endif

#if !defined HAVE_MEMMOVE && defined HAVE_BCOPY
#define memmove(D,S,C) bcopy (S,D,C)
#define HAVE_MEMMOVE 2
#else
/* void memmove (char*, const char*, unsigned); */
#endif

#ifndef HAVE_STPCPY
#define stpcpy(D,S) (strcpy((D),(S)) + strlen((S)))
#endif

#ifndef HAVE_STRDUP
char* strdup (const char* s);
#endif

#if !defined HAVE_STRERROR && !defined HAVE_SYS_ERRLIST
   /* well if it doesn't exist, you'll have to write it yourself */
   extern char* sys_errlist [];
#  define strerror(x) sys_errlist[n]
#endif

#ifndef HAVE_REMOVE
#define remove unlink
#endif

#ifndef HAVE_RENAME
int rename (const char*, const char*);
#endif

#ifndef HAVE_ACCESS
int access (const char* fn, int how);
#endif

#ifndef HAVE_GETCWD
#define getcwd(P,L) getwd(P)
#endif

#ifndef HAVE_TRUNCATE
int truncate (const char* path, long length);
#endif

#ifndef HAVE_RAISE
#define raise(X) kill (getpid (), X)
#endif

#ifndef HAVE_OPTIND
extern int optind;
extern char* optarg;
#endif
#endif

/*@}*/

