#ifndef __P4_CONFIG_H
#define __P4_CONFIG_H

#include "config.h"

#if ! SIZEOF_CHAR
/* we had been guessing the sizes due to cross-compiling */
/* now we look for definitions of already known cpus */
#include "p4_cpuxx.h"
#endif

/* a cell has atleast the size of a pointer but the type of an integer */

#if SIZEOF_VOIDP <= SIZEOF_INT
#define SIZEOF_CELL SIZEOF_INT
#define CELLSIZE SIZEOF_CELL
#define CELL_TYPE int
#elif SIZEOF_VOIDP <= SIZEOF_LONG
#define SIZEOF_CELL SIZEOF_LONG
#define CELLSIZE SIZEOF_CELL
#define CELL_TYPE long
#else
#error cannot detect cell type from size of 'int' or 'long'
#endif

#if SIZEOF_CELL / 2 == SIZEOF_INT
#define  HALFCELL_TYPE int
#elif SIZEOF_CELL / 2 == SIZEOF_SHORT
#define HALFCELL_TYPE short
#else
#define HALFCELL_TYPE char
#endif

#define CELL_ALIGN SIZEOF_INT
#define SFLOAT_ALIGN SIZEOF_FLOAT
#define DFLOAT_ALIGN SIZEOF_DOUBLE

#ifdef WORDS_BIG_ENDIAN
#define HIGHBYTE_FIRST 1
#endif

#if !defined(UNIX_FILENAMES) && !defined(DOS_FILENAMES) && !defined(URL_FILENAMES)
# ifdef HAVE_LONG_FILE_NAMES
# define UNIX_FILENAMES 1
# define ISO_CHARSET 1
# else
# define DOS_FILENAMES 1
# define IBMPC_CHARSET 1
# endif
#endif

#ifdef HAVE_VXWORKS_H
# define NO_SYSTEM
# define STATIC_MAIN
# ifndef __vxworks
# define __vxworks 1
# endif
# ifndef VXWORKS
# define VXWORKS 1
# endif
# ifndef VxWorks
# define VxWorks 1
# endif
#endif

#if defined SYS_k1297 || defined SYS_k1205
#ifndef _K12_SOURCE
#define _K12_SOURCE 1
#endif
#endif

#endif
