/** @name p4words.c --- Vocabularies and lists of words to preload.
 *
 *  Copyright (C) Tektronix, Inc. 1998 - 2000. All rights reserved.
 *
 *  @see    LGPL
 *  @author Tektronix CTE             @(#) %derived_by: guidod %
 *  @version %version: 4.27 %
 *    (%date_modified: Thu Jan 27 21:37:21 2000 %)
 */
/*@{*/
#if defined(__version_control__) && defined(__GNUC__)
static char* id __attribute__((unused)) = 
      "@(#) $Id: %full_filespec: p4words.c~4.27:csrc:bln_12xx!4 %4 % $";
#endif

#define _P4_SOURCE 1

#include "p4sys.h"
#include "support.h"

extern const p4Words
  P4WORDS(core),	P4WORDS(block),
  P4WORDS(double),	P4WORDS(exception),
  P4WORDS(facility),	P4WORDS(file),
#ifndef P4_NO_FP
  P4WORDS(floating), 
#endif
  P4WORDS(locals),
  P4WORDS(memory),	P4WORDS(toolkit),
  P4WORDS(search),	P4WORDS(string),
  P4WORDS(forth_83),	P4WORDS(lpf83),
  P4WORDS(misc),	P4WORDS(debug),
  P4WORDS(shell),	P4WORDS(system),
  P4WORDS(term),
  P4WORDS(signals),	P4WORDS(your);

P4_LOADLIST(forth) =
{
  P4_LOAD_INTO, "FORTH",
  &P4WORDS(search),       /* there's no only-set anymore here! *GD*/
  &P4WORDS(core),	&P4WORDS(block),
  &P4WORDS(double),	&P4WORDS(exception),
  &P4WORDS(facility),	&P4WORDS(file),
#ifndef P4_NO_FP
  &P4WORDS(floating), 
#endif
  &P4WORDS(locals), 	&P4WORDS(memory),	
  &P4WORDS(toolkit), 	&P4WORDS(string), 
  P4_LOAD_ORDER, "FORTH",
  P4_LOAD_END
};

P4_LOADLIST(extensions) =
{
  P4_LOAD_INTO, "EXTENSIONS", 
  &P4WORDS(forth_83), 	&P4WORDS(lpf83), 
  &P4WORDS(misc), 	&P4WORDS(debug), 
  &P4WORDS(system), 	&P4WORDS(shell), 
  &P4WORDS(term),
  &P4WORDS(signals), 	&P4WORDS(your), 
  P4_LOAD_ORDER, "EXTENSIONS",
  P4_LOAD_END
};


#ifdef P4_MODULES

extern void p4_decompile_rest ();

#include "lined.h"

void*
p4_lined_executes (void* a)
{
  void* R = PFE.accept_lined.executes;
  PFE.accept_lined.executes = a;
  return R;
}

void* p4_wait_for_stdin (void* a)
{
  void* R = PFE.wait_for_stdin;
  PFE.wait_for_stdin = a;
  return R;
}

#endif

/*@}*/
