/** @name Version File
 *
 *  Copyright (C) Tektronix, Inc. 1998 - 2000.  All rights reserved.
 *
 *  @see     GNU LGPL
 *  @author  Tektronix CTE              @(#) %derived_by: guidod %
 *  @version %version: 4.29 %
 *    (%date_modified: Tue Apr 11 15:49:13 2000 %)
 *
 *  @description
 *      the version-file is touched everytime pfe is compiled, 
 *      there are some internal functions in the version-file 
 *      that print out compile-time, -date, -version and the
 *      lisence of course.
 */
/*@{*/
#if defined(__version_control__) && defined(__GNUC__)
static char* id __attribute__((unused)) = 
      "@(#) $Id: %full_filespec: version.c~4.29:csrc:bln_12xx!4 % $";
#endif

#define _P4_SOURCE 1

#include "p4e.h"
#include "p4_macro.h"
 
#ifndef MAKETIME
#define MAKETIME __TIME__
#endif

#ifndef MAKEDATE 
#define MAKEDATE __DATE__
#endif

char p4_version_string [] =
	"Portable Forth Environment "P4_VERSION" (" MAKEDATE " " MAKETIME "+00)";

char p4_copyright_string [] =
	"\nCopyright (C) Dirk Uwe Zoller 1993 - 1995."
	"\nCopyright (C) Tektronix, Inc. 1998 - 2000.";

char p4_license_string [] =
	"\n"
	"\nThis program is free software; you can redistribute it and/or"
	"\nmodify it under the terms of the GNU Library General Public"
	"\nLicense as published by the Free Software Foundation; either"
	"\nversion 2 of the License, or (at your option) any later version. ";

char p4_warranty_string [] =
	"\n"
	"\nThis program is distributed in the hope that it will be useful,"
	"\nbut WITHOUT ANY WARRANTY; without even the implied warranty of"
	"\nMERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU"
	"\nLibrary General Public License for more details."
	"\n"
	"\nYou should have received a copy of the GNU Library General Public"
	"\nLicense along with this program; if not, write to the Free Software"
	"\nFoundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA. ";

char p4_compile_date [] = MAKEDATE;
char p4_compile_time [] = MAKETIME;

p4ucell
p4_version_code (void)
/* return a magic-number identifiing the exact version */
{
  static char *str [] = { 
    p4_version_string, 
    p4_compile_date, 
    p4_compile_time 
  };
  p4ucell n = 0;
  int i;
  char *p;

  for (i = 0; i < DIM (str); i++)
    for (p = str [i]; *p; p++)
      n = n * 7 + *p - '@';
  return n;
}

/*@}*/
